﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DataGridView_ColSpan_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.AddRange(new DataColumn[4] { new DataColumn("Id", typeof(int)),
    new DataColumn("Name", typeof(string)),
    new DataColumn("City", typeof(string)),
    new DataColumn("Country",typeof(string)) });
            dt.Rows.Add(1, "John Hammond", "Chicago", "United States");
            dt.Rows.Add(2, "Mudassar Khan", "Mumbai", "India");
            dt.Rows.Add(3, "Suzanne Mathews", "Paris", "France");
            dt.Rows.Add(4, "Robert Schidner", "Moscow", "Russia");
            this.dataGridView1.DataSource = dt;
        }

        private void dataGridView1_Paint(object sender, PaintEventArgs e)
        {
            //Offsets to adjust the position of the merged Header.
            int heightOffset = -5;
            int widthOffset = -2;
            int xOffset = 0;
            int yOffset = 4;

            //Index of Header column from where the merging will start.
            int columnIndex = 2;

            //Number of Header columns to be merged.
            int columnCount = 2;

            //Get the position of the Header Cell.
            Rectangle headerCellRectangle = dataGridView1.GetCellDisplayRectangle(columnIndex, 0, true);

            //X coordinate  of the merged Header Column.
            int xCord = headerCellRectangle.Location.X + xOffset;

            //Y coordinate  of the merged Header Column.
            int yCord = headerCellRectangle.Location.Y - headerCellRectangle.Height + yOffset;

            //Calculate Width of merged Header Column by adding the widths of all Columns to be merged.
            int mergedHeaderWidth = dataGridView1.Columns[columnIndex].Width + dataGridView1.Columns[columnIndex + columnCount - 1].Width + widthOffset;

            //Generate the merged Header Column Rectangle.
            Rectangle mergedHeaderRect = new Rectangle(xCord, yCord, mergedHeaderWidth, headerCellRectangle.Height + heightOffset);

            //Draw the merged Header Column Rectangle.
            e.Graphics.FillRectangle(new SolidBrush(Color.White), mergedHeaderRect);

            //Draw the merged Header Column Text.
            e.Graphics.DrawString("Address", dataGridView1.ColumnHeadersDefaultCellStyle.Font, Brushes.Black, xCord + 2, yCord + 3);
        }
    }
}
